import pytest

from mlair.reference_models.reference_model_intellio3_v1 import IntelliO3Reference
from mlair.reference_models.abstract_reference_model import AbstractReferenceB2share


class TestIntelliO3Reference:

    @pytest.fixture
    def io3(self):
        return IntelliO3Reference("IntelliO3-test")

    def test_init_none_path(self):
        io3 = IntelliO3Reference("IntelliO3-test")
        assert isinstance(io3, IntelliO3Reference)
        assert io3.ref_name == "IntelliO3-test"
        assert io3.ref_store_path == "IntelliO3-test/"
        assert io3.tmp_extract_path == "tmp_downloads/"
        assert io3.orig_forecast_path == "IntelliO3-ts/IntelliO3-ts_network/forecasts/"
        assert io3.file_pattern == "forecasts_DE?????_test.nc"
        assert io3.b2share_key == "IntelliO3-ts.tar.gz"
        assert io3.b2share_bucket == "0cae9db2-f388-4136-8d28-9d9c5665d641"
        assert io3.b2share_hosturl == "https://b2share.eudat.eu"

    def test_init_extra_path(self):
        io3 = IntelliO3Reference("IntelliO3-test", "DummyExtraPath/")
        assert isinstance(io3, IntelliO3Reference)
        assert io3.ref_store_path == "DummyExtraPath/"

    def test_inheritance(self):
        assert issubclass(IntelliO3Reference, AbstractReferenceB2share)

    def test_untar_forecasts(self, io3):
        pass

    def test_file_list(self):
        pass

    def test_read_and_drop(self):
        pass

    def test_make_reference_available_locally(self):
        io3 = IntelliO3Reference("IntelliO3-test", "DummyExtraPath/")

